<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Tugas Vue Router</title>
</head>

<body>
    <div id="app">
        
        <!-- Pengganti tag < a href=""> /a> -->
        <router-link to="/"> alluser || </router-link>
        <router-link to="/user"> user login  ||</router-link>
        <router-link to="/admin"> Admin login       ||</router-link>

        
        <hr>
        <!-- Untuk Menampilkan component secara dinamis, sesuai dengan route yang diakses -->
        <router-view :formuser='formUser' :auth='auth' :admin='admin' :users='Users' :idselected='idSelected'
            @inputformuser='inputFormUser($event)' @login='logIn()' @loginadmin='logInAdmin()'
            @delete-user='deleteUser($event)'>
        </router-view>
    </div>
    <script src="https://unpkg.com/vue/dist/vue.js"></script>
    <script src="https://unpkg.com/vue-router/dist/vue-router.js"></script>
    <script type='module'>
        // import { alluser } from './alluser.js'
        // import { user } from './user.js' 
        // import { admin } from './admin.js'

        const alluser = {
        //Input form tombol Login belum diaktifkan
        template: `<div>
            Ini Halaman admin untuk diakses  ALL User
            <br>
            silahkan login
            <br>

            <input type="text" v-model="userform" @input="$emit('inputformuser', userform)">
            <button @click="$emit('login')">
                Login User</button>
            <button @click="$emit('loginadmin')">
                Login Admin</button>

        </div>`,
        props: ['formuser'],
        watch: {
        formuser: function (newVal, oldVal) {
        this.userform = newVal
        }
        },
        data() {
        return {
        userform: ''
        }
        }
        }

        const user = {
        template: `<div>
            <h3>Ini Halaman admin untuk diakses User</h3>
                
            </div>`,
        props: ['auth'],
        beforeRouteEnter (to, from, next) {
            if(to.matched.some(record=>record.meta.login)){
            
                if(!vm.auth){
                    alert('Silakan Login')
                    next(false)
                }else{
                    next()
                    alert('klik ok untuk melanjutkan')
                }
            }
        }
        }

        const admin = {
        template: `<div>
            <h3>Ini Halaman admin untuk diakses Admin</h3>
            </div>`,
            props: ['users', 'idselected', 'admin', 'auth'],

        beforeRouteEnter (to, from, next) {
            if(to.matched.some(record=>record.meta.admin)){
                if(vm.auth&&vm.admin){
                    next()
                    alert('klik ok untuk melanjutkan')
                }else{
                    alert('Halaman ini hanya dapat diakses oleh Admin')
                    next(false)                    
                }
            }
        }
        }

      
        const routes = [{
        path: '/', component: alluser, alias: '/alluser'
        },
        {
        path: '/user', component: user, meta: {login:true}
        },
        {
        path: '/admin', component: admin, meta: {admin:true}
        },
        {
        path: '*', redirect: '/'
        }
        ]

        
        const router = new VueRouter({
        routes
        })

       

        export var vm = new Vue({
        el: '#app',
        router,
        components: {
        'alluser': alluser,
        'user': user,
        'admin': admin,
        },
        data : {
            Users: [
            ],
        formUser: '',
        auth : false,
        admin : false,
        idSelected: null
        },
        methods : {
            deleteUser: function (id) {
                let confirmation = confirm("Anda yakin ?")
                    if (confirmation) {
                        this.Users = this.Users.filter(function (item, index) {
                        return index != id
                        })
                    }
            },

            inputFormUser: function (formuser) {
            this.formUser = formuser
            },

            logIn: function(){
                alert('kamu login '+this.formUser)
                console.log('sudah login'+this.formUser)
                this.formUser=''
                this.auth = true
            },
            
            logInAdmin: function(){
                alert('kamu login admin '+this.formUser)
                console.log('sudah login admin '+this.formUser)
                this.formUser=''
                this.auth = true
                this.admin = true
            },
            
            }
        })
    </script>
</body>

</html>
